## jsonnet 0.14.0+ds

=== Makefile ===
# Copyright 2015 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

################################################################################
# User-servicable parts:
################################################################################

# C/C++ compiler; to use Clang, build with `make CC=clang CXX=clang++`
CXX ?= g++
CC ?= gcc

# Emscripten -- For Jsonnet in the browser
EMCXX ?= em++
EMCC ?= emcc

CP ?= cp
OD ?= od

OPT ?= -O3

PREFIX ?= /usr/local

CXXFLAGS ?= -g $(OPT) -Wall -Wextra -Woverloaded-virtual -pedantic -std=c++0x -fPIC
CXXFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json
CFLAGS ?= -g $(OPT) -Wall -Wextra -pedantic -std=c99 -fPIC
CFLAGS += -Iinclude
MAKEDEPENDFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json
EMCXXFLAGS = $(CXXFLAGS) -g0 -Os --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s OUTLINING_LIMIT=10000 -s RESERVED_FUNCTION_POINTERS=20 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
EMCFLAGS = $(CFLAGS) --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
LDFLAGS ?=


SHARED_LDFLAGS ?= -shared

VERSION := $(shell grep '\#define.*LIB_JSONNET_VERSION' include/libjsonnet.h | head -n 1 | cut -f 2 -d '"' | sed 's/^v//g' )
SOVERSION = 0

################################################################################
# End of user-servicable parts
################################################################################

LIB_SRC = \
	core/desugarer.cpp \
	core/formatter.cpp \
	core/lexer.cpp \
	core/libjsonnet.cpp \
	core/parser.cpp \
	core/pass.cpp \
	core/static_analysis.cpp \
	core/string_utils.cpp \
	core/vm.cpp \
	third_party/md5/md5.cpp

LIB_OBJ = $(LIB_SRC:.cpp=.o)

LIB_CPP_SRC = \
	cpp/libjsonnet++.cpp

LIB_CPP_OBJ = $(LIB_OBJ) $(LIB_CPP_SRC:.cpp=.o)

BINS = \
	jsonnet \
	jsonnetfmt

LIBS = \
	libjsonnet.so \
	libjsonnet.so.$(SOVERSION) \
	libjsonnet.so.$(VERSION) \
	libjsonnet++.so \
	libjsonnet++.so.$(SOVERSION) \
	libjsonnet++.so.$(VERSION) \

ALL = \
	libjsonnet_test_snippet \
	libjsonnet_test_file \
	libjsonnet.js \
	doc/js/libjsonnet.js \
	$(BINS) \
	$(LIBS) \
	$(LIB_OBJ)

# public headers
INCS = \
	include/libjsonnet.h \
	include/libjsonnet_fmt.h \
	include/libjsonnet++.h

ALL_HEADERS = \
	core/ast.h \
	core/desugarer.h \
	core/formatter.h \
	core/lexer.h \
	core/parser.h \
	core/state.h \
	core/static_analysis.h \
	core/static_error.h \
	core/string_utils.h \
	core/vm.h \
	core/std.jsonnet.h \
	third_party/md5/md5.h \
	third_party/json/json.hpp \
	$(INCS)


default: $(LIBS) $(BINS)

bins: jsonnet jsonnetfmt
libs: libjsonnet.so libjsonnet++.so

SONAME = -soname
ifeq ($(shell uname -s),Darwin)
	SONAME = -install_name
endif

default: jsonnet jsonnetfmt

install: bins libs
	mkdir -p $(PREFIX)/bin
	cp $(BINS) $(PREFIX)/bin/
	mkdir -p $(PREFIX)/lib
	cp $(LIBS) $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include
	cp $(INCS) $(PREFIX)/include/

all: $(ALL)

test: jsonnet jsonnetfmt libjsonnet.so libjsonnet_test_snippet libjsonnet_test_file
	./tests.sh

reformat:
	clang-format -i -style=file **/*.cpp **/*.h

test-formatting:
	test "`clang-format -style=file -output-replacements-xml **/*.cpp **/*.h | grep -c "<replacement "`" == 0

MAKEDEPEND_SRCS = \
	cmd/jsonnet.cpp \
	cmd/jsonnetfmt.cpp \
	core/libjsonnet_test_snippet.c \
	core/libjsonnet_test_file.c

depend: core/std.jsonnet.h
	rm -f Makefile.depend
	for FILE in $(LIB_SRC) $(MAKEDEPEND_SRCS) ; do $(CXX) -MM $(CXXFLAGS) $$FILE -MT $$(dirname $$FILE)/$$(basename $$FILE .cpp).o >> Makefile.depend ; done

core/desugarer.cpp: core/std.jsonnet.h

# Object files
%.o: %.cpp
	$(CXX) -c $(CXXFLAGS) $< -o $@

# Commandline executable.
jsonnet: cmd/jsonnet.cpp cmd/utils.cpp $(LIB_OBJ)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $< cmd/utils.cpp $(LIB_SRC:.cpp=.o) -o $@

# Commandline executable (reformatter).
jsonnetfmt: cmd/jsonnetfmt.cpp cmd/utils.cpp $(LIB_OBJ)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $< cmd/utils.cpp $(LIB_SRC:.cpp=.o) -o $@

# C binding.
libjsonnet.so.$(VERSION): $(LIB_OBJ)
	$(CXX) $(LDFLAGS) $(LIB_OBJ) $(SHARED_LDFLAGS) -Wl,$(SONAME),libjsonnet.so.$(SOVERSION) -o $@

libjsonnet++.so.$(VERSION): $(LIB_CPP_OBJ)
	$(CXX) $(LDFLAGS) $(LIB_CPP_OBJ) $(SHARED_LDFLAGS) -Wl,$(SONAME),libjsonnet++.so.$(SOVERSION) -o $@

%.so.$(SOVERSION): %.so.$(VERSION)
	ln -sf $< $@

%.so: %.so.$(SOVERSION)
	ln -sf $< $@

# JavaScript build of C binding
JS_EXPORTED_FUNCTIONS = 'EXPORTED_FUNCTIONS=["_jsonnet_make", "_jsonnet_evaluate_snippet", "_jsonnet_fmt_snippet", "_jsonnet_ext_var", "_jsonnet_ext_code", "_jsonnet_tla_var", "_jsonnet_tla_code", "_jsonnet_realloc", "_jsonnet_destroy", "_jsonnet_import_callback"]'

JS_RUNTIME_METHODS = 'EXTRA_EXPORTED_RUNTIME_METHODS=["cwrap", "_free", "getValue", "lengthBytesUTF8", "_malloc", "UTF8ToString", "setValue", "stringToUTF8", "addFunction"]'


libjsonnet.js: $(LIB_SRC) $(ALL_HEADERS)
	$(EMCXX) -s WASM=0 -s $(JS_EXPORTED_FUNCTIONS) -s $(JS_RUNTIME_METHODS) $(EMCXXFLAGS) $(LDFLAGS) $(LIB_SRC) -o $@

# Copy javascript build to doc directory
doc/js/libjsonnet.js: libjsonnet.js
	$(CP) $^ $@

# Tests for C binding.
LIBJSONNET_TEST_SNIPPET_SRCS = \
	core/libjsonnet_test_snippet.c \
	libjsonnet.so \
	include/libjsonnet.h

libjsonnet_test_snippet: $(LIBJSONNET_TEST_SNIPPET_SRCS)
	$(CC) $(CFLAGS) $(LDFLAGS) $< -L. -ljsonnet -o $@

LIBJSONNET_TEST_FILE_SRCS = \
	core/libjsonnet_test_file.c \
	libjsonnet.so \
	include/libjsonnet.h

libjsonnet_test_file: $(LIBJSONNET_TEST_FILE_SRCS)
	$(CC) $(CFLAGS) $(LDFLAGS) $< -L. -ljsonnet -o $@

# Encode standard library for embedding in C
core/%.jsonnet.h: stdlib/%.jsonnet
	(($(OD) -v -Anone -t u1 $< \
		| tr " " "\n" \
		| grep -v "^$$" \
		| tr "\n" "," ) && echo "0") > $@
	echo >> $@


RELEASE_FILE = jsonnet-bin.tar.gz

$(RELEASE_FILE): bins
	tar czf $@ $(BINS)

dist: $(RELEASE_FILE)

clean:
	rm -vf */*~ *~ .*~ */.*.swp .*.swp $(ALL) *.o core/*.jsonnet.h Makefile.depend *.so.* $(RELEASE_FILE)

-include Makefile.depend

.PHONY: default all depend clean reformat test test-formatting

=== cpp/CMakeLists.txt ===
# libjsonnet++

set(LIBJSONNETPP_HEADERS
    ../include/libjsonnet++.h
)

set(LIBJSONNETPP_SOURCE
    libjsonnet++.cpp
)

add_library(libjsonnet++ SHARED ${LIBJSONNETPP_HEADERS} ${LIBJSONNETPP_SOURCE})
add_dependencies(libjsonnet++ jsonnet)
# target_link_libraries(libjsonnet libjsonnet)

# CMake prepends CMAKE_SHARED_LIBRARY_PREFIX to shared libraries, so without
# this step the output would be |liblibjsonnet|.
set_target_properties(libjsonnet++ PROPERTIES OUTPUT_NAME jsonnet++
	VERSION     "0.14.0"
	SOVERSION   "0"
	PUBLIC_HEADER "${LIB_HEADER}")
install(TARGETS libjsonnet++
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

if (BUILD_STATIC_LIBS)
    # Static library for jsonnet command-line tool.
    add_library(libjsonnet++_static STATIC ${LIBJSONNETPP_SOURCE})
    add_dependencies(libjsonnet++_static jsonnet)
    target_link_libraries(libjsonnet++_static libjsonnet_static)
    set_target_properties(libjsonnet++_static PROPERTIES OUTPUT_NAME jsonnet++)
    install(TARGETS libjsonnet++_static DESTINATION "${CMAKE_INSTALL_LIBDIR}")
endif()

if (BUILD_SHARED_BINARIES OR NOT BUILD_STATIC_LIBS)
    add_library(libjsonnet++_for_binaries ALIAS libjsonnet++)
else()
    add_library(libjsonnet++_for_binaries ALIAS libjsonnet++_static)
endif()

# Tests
function(add_test_executablepp test_name)
    if (EXISTS ${CMAKE_CURRENT_LIST_DIR}/${test_name}.cpp)
        set(TEST_EXT cpp)
    else()
        set(TEST_EXT c)
    endif()
    add_executable(${test_name} ${test_name}.${TEST_EXT})

    add_dependencies(${test_name} libjsonnet++_for_binaries libjsonnet_for_binaries GTest::Main)
    target_link_libraries(
        ${test_name} GTest::GTest GTest::Main libjsonnet++_for_binaries libjsonnet_for_binaries)
endfunction()

if (BUILD_TESTS)
    add_test_executablepp(libjsonnet++_test)
    # Run this in the source tree because it needs to access testdata files.
    add_test(NAME libjsonnet++_test COMMAND ${GLOBAL_OUTPUT_PATH}/libjsonnet++_test WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")
endif()

## jsonnet 0.13.0+ds

=== debian/changelog ===
jsonnet (0.13.0+ds-1) unstable; urgency=medium

  * New upstream version 0.13.0+ds
  * Remove merged patches and refresh remaining ones.
  * Install new executable usr/bin/jsonnetfmt .
  * Update lintian overrides.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 25 Jun 2019 05:01:43 +0000

jsonnet (0.12.1+ds-1) unstable; urgency=low

  * Initial release. (Closes: #922047)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 18 May 2019 05:56:07 +0000

=== debian/control ===
Source: jsonnet
Section: devel
Homepage: https://github.com/google/jsonnet
Priority: optional
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/debian/jsonnet.git
Vcs-Browser: https://salsa.debian.org/debian/jsonnet
Maintainer: Mo Zhou <cdluminate@gmail.com>
Build-Depends: debhelper-compat (= 12), python3-all, python3-all-dev, cmake,
 dh-python, googletest, python3-setuptools,

Package: jsonnet
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: data templating language
 A data templating language for app and tool developers
 .
  * Generate config data
  * Side-effect free
  * Organize, simplify, unify
  * Manage sprawling config
 .
 A simple extension of JSON
 .
  * Open source (Apache 2.0)
  * Familiar syntax
  * Reformatter, linter
  * Editor & IDE integrations
  * Formally specified
 .
 Eliminate duplication with object-orientation. Or, use functions.
 Integrate with existing / custom applications. Generate JSON, YAML,
 INI, and other formats.
 .
 This package ships the binary executable.

Package: libjsonnet0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: data templating language (lib)
 A data templating language for app and tool developers
 .
  * Generate config data
  * Side-effect free
  * Organize, simplify, unify
  * Manage sprawling config
 .
 A simple extension of JSON
 .
  * Open source (Apache 2.0)
  * Familiar syntax
  * Reformatter, linter
  * Editor & IDE integrations
  * Formally specified
 .
 Eliminate duplication with object-orientation. Or, use functions.
 Integrate with existing / custom applications. Generate JSON, YAML,
 INI, and other formats.
 .
 This package ships the shared object.

Package: libjsonnet-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
Description: data templating language (devel)
 A data templating language for app and tool developers
 .
  * Generate config data
  * Side-effect free
  * Organize, simplify, unify
  * Manage sprawling config
 .
 A simple extension of JSON
 .
  * Open source (Apache 2.0)
  * Familiar syntax
  * Reformatter, linter
  * Editor & IDE integrations
  * Formally specified
 .
 Eliminate duplication with object-orientation. Or, use functions.
 Integrate with existing / custom applications. Generate JSON, YAML,
 INI, and other formats.
 .
 This package ships the development files.

Package: python3-jsonnet
Section: python
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
Description: data templating language (Python)
 A data templating language for app and tool developers
 .
  * Generate config data
  * Side-effect free
  * Organize, simplify, unify
  * Manage sprawling config
 .
 A simple extension of JSON
 .
  * Open source (Apache 2.0)
  * Familiar syntax
  * Reformatter, linter
  * Editor & IDE integrations
  * Formally specified
 .
 Eliminate duplication with object-orientation. Or, use functions.
 Integrate with existing / custom applications. Generate JSON, YAML,
 INI, and other formats.
 .
 This package ships the Python binding.

=== debian/tests/control ===
Test-Command: DISABLE_LIB_TESTS=1 JSONNET_BIN=/usr/bin/jsonnet sh tests.sh
Depends: jsonnet, python3

## jsonnet 0.14.0+ds

=== debian/changelog ===
jsonnet (0.14.0+ds-1) unstable; urgency=medium

  * New upstream version 0.14.0+ds
  * Install the libjsonnet++ dynanic/static libraries. (Closes: #931011)
  * Add the missing B-D libgtest-dev.
  * Update autopkgtest control file.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 18 Sep 2019 21:33:45 +0800

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/jsonnet
 Maintainer: Mo Zhou <cdluminate@gmail.com>
 Build-Depends: debhelper-compat (= 12), python3-all, python3-all-dev, cmake,
- dh-python, googletest, python3-setuptools,
+ dh-python, googletest, libgtest-dev, python3-setuptools,
 
 Package: jsonnet
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Ithird_party/md5 -Ithird_party/json -Iinclude -fPIC
export DEB_CXXFLAGS_MAINT_APPEND = -Ithird_party/md5 -Ithird_party/json -Iinclude -fPIC

%:
	dh $@ -Scmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DUSE_SYSTEM_GTEST=ON \
		-DBUILD_JSONNET=ON \
		-DBUILD_TESTS=ON

override_dh_auto_build:
	dh_auto_build
	python3 setup.py build

override_dh_auto_install:
	dh_auto_install
	python3 setup.py install --install-layout=deb \
		--root=$(shell pwd)/debian/tmp

## jsonnet 0.15.0%2Bds

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # CMake prepends CMAKE_SHARED_LIBRARY_PREFIX to shared libraries, so without
 # this step the output would be |liblibjsonnet|.
 set_target_properties(libjsonnet++ PROPERTIES OUTPUT_NAME jsonnet++
-	VERSION     "0.14.0"
+	VERSION     "0.15.0"
 	SOVERSION   "0"
 	PUBLIC_HEADER "${LIB_HEADER}")
 install(TARGETS libjsonnet++

## jsonnet 0.15.0+ds

=== CMakeLists.txt ===
# Travis CI runs CMake 2.8.7 so we are pinned to that verison.
cmake_minimum_required(VERSION 2.8.7)
project(jsonnet C CXX)

include(ExternalProject)
include(GNUInstallDirs)

# User-configurable options.
option(BUILD_JSONNET "Build jsonnet command-line tool." ON)
option(BUILD_JSONNETFMT "Build jsonnetfmt command-line tool." ON)
option(BUILD_TESTS "Build and run jsonnet tests." ON)
option(BUILD_STATIC_LIBS "Build a static libjsonnet." ON)
option(BUILD_SHARED_BINARIES "Link binaries to the shared libjsonnet instead of the static one." OFF)
option(USE_SYSTEM_GTEST "Use system-provided gtest library" OFF)
option(USE_SYSTEM_JSON "Use the system-provided json library" OFF)
set(GLOBAL_OUTPUT_PATH_SUFFIX "" CACHE STRING
    "Output artifacts directory.")

# Discourage in-source builds because they overwrite the hand-written Makefile.
# Use `cmake . -B<dir>` or the CMake GUI to do an out-of-source build.
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} AND
        ${CMAKE_GENERATOR} MATCHES "Makefile")
    message(WARNING "In-source builds with the a makefile generator overwrite the handwritten Makefile. Out-of-source builds are recommended for this project.")
endif()

# Disable CMake >3.0 warnings on Mac OS.
set(CMAKE_MACOSX_RPATH 1)

# Set output paths.
set(GLOBAL_OUTPUT_PATH "${PROJECT_BINARY_DIR}/${GLOBAL_OUTPUT_PATH_SUFFIX}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${GLOBAL_OUTPUT_PATH})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${GLOBAL_OUTPUT_PATH})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${GLOBAL_OUTPUT_PATH})

# Include external googletest project. This runs a CMake sub-script
# (CMakeLists.txt.in) that downloads googletest source. It's then built as part
# of the jsonnet project. The conventional way of handling CMake dependencies is
# to use a find_package script, which finds and installs the library from
# known locations on the local machine. Downloading the library ourselves
# allows us to pin to a specific version and makes things easier for users
# who don't have package managers.
if (BUILD_TESTS AND NOT USE_SYSTEM_GTEST)
    enable_testing()

    # Generate and download googletest project.
    set(GOOGLETEST_DIR ${GLOBAL_OUTPUT_PATH}/googletest-download)
    configure_file(CMakeLists.txt.in ${GOOGLETEST_DIR}/CMakeLists.txt)
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
            RESULT_VARIABLE result
            WORKING_DIRECTORY ${GOOGLETEST_DIR}
    )
    if(result)
        message(FATAL_ERROR "googletest download failed: ${result}")
    endif()

    # Build googletest.
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
        RESULT_VARIABLE result
        WORKING_DIRECTORY ${GOOGLETEST_DIR})
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Prevent overriding the parent project's compiler/linker
    # settings on Windows
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${GLOBAL_OUTPUT_PATH}/googletest-src
                                     ${GLOBAL_OUTPUT_PATH}/googletest-build)

    # Include googletest headers.
    include_directories("${gtest_SOURCE_DIR}/include")

	# Alias the targets to their namespaced versions.
	add_library(GTest::GTest ALIAS gtest)
	add_library(GTest::Main ALIAS gtest_main)

elseif (BUILD_TESTS AND USE_SYSTEM_GTEST)
	enable_testing()
	find_package(GTest REQUIRED)
endif()

if(USE_SYSTEM_JSON)
    find_package(nlohmann_json 3.6.1 REQUIRED)
else()
    add_subdirectory(third_party/json)
endif()

# Compiler flags.
if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" OR
        ${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    set(OPT "-O3")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra -pedantic -std=c99 -O3 ${OPT}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra -Woverloaded-virtual -pedantic -std=c++0x -fPIC ${OPT}")
else()
    # TODO: Windows support.
    message(FATAL_ERROR "Compiler ${CMAKE_CXX_COMPILER_ID} not supported")
endif()

# Look for libraries in global output path.
link_directories(${GLOBAL_OUTPUT_PATH})

# Targets

include_directories(
    include
    third_party/md5
    core
    cpp)

if (BUILD_TESTS)
    # Set JSONNET_BIN variable required for regression tests.
    file(TO_NATIVE_PATH ${GLOBAL_OUTPUT_PATH}/jsonnet JSONNET_BIN)
endif()

add_subdirectory(include)
add_subdirectory(stdlib)
add_subdirectory(third_party/md5)
add_subdirectory(core)
add_subdirectory(cpp)
add_subdirectory(cmd)
add_subdirectory(test_suite)

if (BUILD_TESTS)
    # s`run_tests` target builds and runs all tests. The cmake-generated `test`
    # target runs tests without building them.
    add_custom_target(run_tests COMMAND ${CMAKE_CTEST_COMMAND}
        DEPENDS libjsonnet_test libjsonnet_test_file libjsonnet_test_snippet
                jsonnet parser_test lexer_test libjsonnet++_test
    )

endif()

=== Makefile ===
--- 
+++ 
@@ -126,12 +126,12 @@
 default: jsonnet jsonnetfmt
 
 install: bins libs
-	mkdir -p $(PREFIX)/bin
-	cp $(BINS) $(PREFIX)/bin/
-	mkdir -p $(PREFIX)/lib
-	cp $(LIBS) $(PREFIX)/lib/
-	mkdir -p $(PREFIX)/include
-	cp $(INCS) $(PREFIX)/include/
+	mkdir -p $(DESTDIR)$(PREFIX)/bin
+	cp $(BINS) $(DESTDIR)$(PREFIX)/bin/
+	mkdir -p $(DESTDIR)$(PREFIX)/lib
+	cp $(LIBS) $(DESTDIR)$(PREFIX)/lib/
+	mkdir -p $(DESTDIR)$(PREFIX)/include
+	cp $(INCS) $(DESTDIR)$(PREFIX)/include/
 
 all: $(ALL)

=== core/CMakeLists.txt ===
# libjsonnet

# Remember to update Bazel and Makefile builds when updating this list!
set(LIBJSONNET_HEADERS
    ast.h
    desugarer.h
    formatter.h
    lexer.h
    ../include/libjsonnet.h
    ../include/libjsonnet_fmt.h
    parser.h
    pass.h
    state.h
    static_analysis.h
    static_error.h
    string_utils.h
    unicode.h
    vm.h)

set(LIBJSONNET_SOURCE
    desugarer.cpp
    formatter.cpp
    lexer.cpp
    libjsonnet.cpp
    parser.cpp
    pass.cpp
    static_analysis.cpp
    string_utils.cpp
    vm.cpp)

add_library(libjsonnet SHARED ${LIBJSONNET_HEADERS} ${LIBJSONNET_SOURCE})
add_dependencies(libjsonnet md5 stdlib)
target_link_libraries(libjsonnet md5 nlohmann_json::nlohmann_json)

file(STRINGS ${CMAKE_SOURCE_DIR}/include/libjsonnet.h JSONNET_VERSION_DEF
     REGEX "[#]define[ \t]+LIB_JSONNET_VERSION[ \t]+")
string(REGEX REPLACE ".*\"v([^\"]+)\".*" "\\1" JSONNET_VERSION ${JSONNET_VERSION_DEF})
message("Extracted Jsonnet version: " ${JSONNET_VERSION})


# CMake prepends CMAKE_SHARED_LIBRARY_PREFIX to shared libraries, so without
# this step the output would be |liblibjsonnet|.
set_target_properties(libjsonnet PROPERTIES OUTPUT_NAME jsonnet
	VERSION     "${JSONNET_VERSION}"
	SOVERSION   "0"
	PUBLIC_HEADER "${LIB_HEADER}")
install(TARGETS libjsonnet
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

if (BUILD_STATIC_LIBS)
    # Static library for jsonnet command-line tool.
    add_library(libjsonnet_static STATIC ${LIBJSONNET_SOURCE})
    add_dependencies(libjsonnet_static md5 stdlib)
    target_link_libraries(libjsonnet_static md5 nlohmann_json::nlohmann_json)
    set_target_properties(libjsonnet_static PROPERTIES OUTPUT_NAME jsonnet)
    install(TARGETS libjsonnet_static DESTINATION "${CMAKE_INSTALL_LIBDIR}")
endif()

if (BUILD_SHARED_BINARIES OR NOT BUILD_STATIC_LIBS)
    add_library(libjsonnet_for_binaries ALIAS libjsonnet)
else()
    add_library(libjsonnet_for_binaries ALIAS libjsonnet_static)
endif()

# Tests

function(add_test_executable test_name)
    if (EXISTS ${CMAKE_CURRENT_LIST_DIR}/${test_name}.cpp)
        set(TEST_EXT cpp)
    else()
        set(TEST_EXT c)
    endif()
    add_executable(${test_name} ${test_name}.${TEST_EXT})

    add_dependencies(${test_name} libjsonnet_for_binaries GTest::Main)
    target_link_libraries(
        ${test_name} GTest::GTest GTest::Main libjsonnet_for_binaries)
endfunction()

if (BUILD_TESTS)
    add_test_executable(lexer_test)
    add_test(lexer_test ${GLOBAL_OUTPUT_PATH}/lexer_test)

    add_test_executable(parser_test)
    add_test(parser_test ${GLOBAL_OUTPUT_PATH}/parser_test)

    add_test_executable(libjsonnet_test)
    add_test(libjsonnet_test ${GLOBAL_OUTPUT_PATH}/libjsonnet_test)

    add_test_executable(libjsonnet_test_file)
    add_test(libjsonnet_test_file
        ${GLOBAL_OUTPUT_PATH}/libjsonnet_test_file
        ${CMAKE_SOURCE_DIR}/test_suite/object.jsonnet)

    set(TEST_SNIPPET "std.assertEqual(({ x: 1, y: self.x } { x: 2 }).y, 2)")
    add_test_executable(libjsonnet_test_snippet)
    add_test(libjsonnet_test_snippet
        ${GLOBAL_OUTPUT_PATH}/libjsonnet_test_snippet ${TEST_SNIPPET})

    add_test(jsonnet_test_snippet
        ${GLOBAL_OUTPUT_PATH}/jsonnet -e ${TEST_SNIPPET})
endif()

=== debian/changelog ===
jsonnet (0.15.0+ds-1build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:20:08 +0100

jsonnet (0.15.0+ds-1) unstable; urgency=medium

  * New upstream version 0.15.0+ds
  * Bump Standards-Version to 4.5.0 (no change).
  * Update my mail address in control and copyright.
  * Specify Rules-Requires-Root: no .

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Feb 2020 11:25:24 +0800

jsonnet (0.14.0+ds-2) unstable; urgency=medium

  * Build extensions for all supported python3 versions. (Closes: #942668)

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 20 Oct 2019 09:40:58 +0800

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,13 @@
 Section: devel
 Homepage: https://github.com/google/jsonnet
 Priority: optional
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/debian/jsonnet.git
 Vcs-Browser: https://salsa.debian.org/debian/jsonnet
-Maintainer: Mo Zhou <cdluminate@gmail.com>
+Maintainer: Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 12), python3-all, python3-all-dev, cmake,
  dh-python, googletest, libgtest-dev, python3-setuptools,
+Rules-Requires-Root: no
 
 Package: jsonnet
 Architecture: any

## jsonnet 0.17.0%2Bds

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 add_dependencies(libjsonnet md5 stdlib)
 target_link_libraries(libjsonnet md5 nlohmann_json::nlohmann_json)
 
-file(STRINGS ${CMAKE_SOURCE_DIR}/include/libjsonnet.h JSONNET_VERSION_DEF
+file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/../include/libjsonnet.h JSONNET_VERSION_DEF
      REGEX "[#]define[ \t]+LIB_JSONNET_VERSION[ \t]+")
 string(REGEX REPLACE ".*\"v([^\"]+)\".*" "\\1" JSONNET_VERSION ${JSONNET_VERSION_DEF})
 message("Extracted Jsonnet version: " ${JSONNET_VERSION})
@@ -48,6 +48,8 @@
 	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
 	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
 	PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
+target_include_directories(libjsonnet INTERFACE
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)
 
 if (BUILD_STATIC_LIBS)
     # Static library for jsonnet command-line tool.
@@ -56,6 +58,8 @@
     target_link_libraries(libjsonnet_static md5 nlohmann_json::nlohmann_json)
     set_target_properties(libjsonnet_static PROPERTIES OUTPUT_NAME jsonnet)
     install(TARGETS libjsonnet_static DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+    target_include_directories(libjsonnet_static INTERFACE
+      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)
 endif()
 
 if (BUILD_SHARED_BINARIES OR NOT BUILD_STATIC_LIBS)
@@ -92,7 +96,7 @@
     add_test_executable(libjsonnet_test_file)
     add_test(libjsonnet_test_file
         ${GLOBAL_OUTPUT_PATH}/libjsonnet_test_file
-        ${CMAKE_SOURCE_DIR}/test_suite/object.jsonnet)
+        ${CMAKE_CURRENT_SOURCE_DIR}/../test_suite/object.jsonnet)
 
     set(TEST_SNIPPET "std.assertEqual(({ x: 1, y: self.x } { x: 2 }).y, 2)")
     add_test_executable(libjsonnet_test_snippet)

=== debian/changelog ===
jsonnet (0.17.0+ds-2) unstable; urgency=medium

  * Fix broken symlinks in libjsonnet-dev due to missing deps (Closes: #985511)

 -- Mo Zhou <lumin@debian.org>  Wed, 24 Mar 2021 09:49:24 +0800

jsonnet (0.17.0+ds-1) unstable; urgency=medium

  * New upstream version 0.17.0+ds
  * Rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Dec 2020 11:12:06 +0800

jsonnet (0.16.0+ds-1) unstable; urgency=medium

  * New upstream version 0.16.0+ds

 -- Mo Zhou <lumin@debian.org>  Sun, 22 Nov 2020 14:34:43 +0800

## jsonnet 0.17.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,20 @@
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${GLOBAL_OUTPUT_PATH})
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${GLOBAL_OUTPUT_PATH})
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${GLOBAL_OUTPUT_PATH})
+
+# Compiler flags.
+if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" OR
+        ${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
+    set(OPT "-O3")
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra -pedantic -std=c99 -O3 ${OPT}")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra -Woverloaded-virtual -pedantic -std=c++11 -fPIC ${OPT}")
+else()
+    # TODO: Windows support.
+    message(FATAL_ERROR "Compiler ${CMAKE_CXX_COMPILER_ID} not supported")
+endif()
+
+set(CMAKE_CXX_STANDARD 11)
+
 
 # Include external googletest project. This runs a CMake sub-script
 # (CMakeLists.txt.in) that downloads googletest source. It's then built as part
@@ -88,17 +102,6 @@
     add_subdirectory(third_party/json)
 endif()
 
-# Compiler flags.
-if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang" OR
-        ${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
-    set(OPT "-O3")
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra -pedantic -std=c99 -O3 ${OPT}")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra -Woverloaded-virtual -pedantic -std=c++0x -fPIC ${OPT}")
-else()
-    # TODO: Windows support.
-    message(FATAL_ERROR "Compiler ${CMAKE_CXX_COMPILER_ID} not supported")
-endif()
-
 # Look for libraries in global output path.
 link_directories(${GLOBAL_OUTPUT_PATH})

=== Makefile ===
--- 
+++ 
@@ -36,7 +36,7 @@
 CFLAGS ?= -g $(OPT) -Wall -Wextra -pedantic -std=c99 -fPIC
 CFLAGS += -Iinclude
 MAKEDEPENDFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json
-EMCXXFLAGS = $(CXXFLAGS) -g0 -Os --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s OUTLINING_LIMIT=10000 -s RESERVED_FUNCTION_POINTERS=20 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
+EMCXXFLAGS = $(CXXFLAGS) --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s INLINING_LIMIT=50 -s RESERVED_FUNCTION_POINTERS=20 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
 EMCFLAGS = $(CFLAGS) --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
 LDFLAGS ?=
 
@@ -184,7 +184,7 @@
 # JavaScript build of C binding
 JS_EXPORTED_FUNCTIONS = 'EXPORTED_FUNCTIONS=["_jsonnet_make", "_jsonnet_evaluate_snippet", "_jsonnet_fmt_snippet", "_jsonnet_ext_var", "_jsonnet_ext_code", "_jsonnet_tla_var", "_jsonnet_tla_code", "_jsonnet_realloc", "_jsonnet_destroy", "_jsonnet_import_callback"]'
 
-JS_RUNTIME_METHODS = 'EXTRA_EXPORTED_RUNTIME_METHODS=["cwrap", "_free", "getValue", "lengthBytesUTF8", "_malloc", "UTF8ToString", "setValue", "stringToUTF8", "addFunction"]'
+JS_RUNTIME_METHODS = 'EXTRA_EXPORTED_RUNTIME_METHODS=["cwrap", "getValue", "lengthBytesUTF8", "UTF8ToString", "setValue", "stringToUTF8", "addFunction"]'
 
 
 libjsonnet.js: $(LIB_SRC) $(ALL_HEADERS)

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -15,13 +15,15 @@
 # CMake prepends CMAKE_SHARED_LIBRARY_PREFIX to shared libraries, so without
 # this step the output would be |liblibjsonnet|.
 set_target_properties(libjsonnet++ PROPERTIES OUTPUT_NAME jsonnet++
-	VERSION     "0.15.0"
+	VERSION     "0.17.0"
 	SOVERSION   "0"
 	PUBLIC_HEADER "${LIB_HEADER}")
 install(TARGETS libjsonnet++
 	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
 	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
 	PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
+target_include_directories(libjsonnet++ INTERFACE
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)
 
 if (BUILD_STATIC_LIBS)
     # Static library for jsonnet command-line tool.
@@ -30,6 +32,8 @@
     target_link_libraries(libjsonnet++_static libjsonnet_static)
     set_target_properties(libjsonnet++_static PROPERTIES OUTPUT_NAME jsonnet++)
     install(TARGETS libjsonnet++_static DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+    target_include_directories(libjsonnet++_static INTERFACE
+      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)
 endif()
 
 if (BUILD_SHARED_BINARIES OR NOT BUILD_STATIC_LIBS)
@@ -55,5 +59,5 @@
 if (BUILD_TESTS)
     add_test_executablepp(libjsonnet++_test)
     # Run this in the source tree because it needs to access testdata files.
-    add_test(NAME libjsonnet++_test COMMAND ${GLOBAL_OUTPUT_PATH}/libjsonnet++_test WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")
+    add_test(NAME libjsonnet++_test COMMAND ${GLOBAL_OUTPUT_PATH}/libjsonnet++_test WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/..")
 endif()

=== test_suite/CMakeLists.txt ===
find_program(BASH bash)
if (BASH STREQUAL "BASH-NOTFOUND")
    message(WARNING "Bash not found, can't run regression tests.")
else()
    # Note: this test relies on the JSONNET_BIN variable, which
    # is set in the root CMakeLists.txt.
    message( "Testing with Jsonnet executable: ${JSONNET_BIN}" )
    add_test(
        NAME regression_test
        COMMAND ${BASH} ${CMAKE_CURRENT_SOURCE_DIR}/run_tests.sh
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
    set_tests_properties(
         regression_test
             PROPERTIES
             ENVIRONMENT JSONNET_BIN=${JSONNET_BIN})

endif()

=== debian/changelog ===
jsonnet (0.17.0+ds-2build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 19:25:16 +0000

jsonnet (0.17.0+ds-2build1) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Oct 2021 06:56:33 +0000

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,11 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	python3 setup.py build
+	for PY in $(shell py3versions -rs); do \
+		$$PY setup.py build; done
 
 override_dh_auto_install:
 	dh_auto_install
-	python3 setup.py install --install-layout=deb \
-		--root=$(shell pwd)/debian/tmp
+	for PY in $(shell py3versions -rs); do \
+		$$PY setup.py install --install-layout=deb \
+		--root=$(shell pwd)/debian/tmp; done

## jsonnet 0.18.0%2Bds

=== Makefile ===
--- 
+++ 
@@ -32,10 +32,10 @@
 PREFIX ?= /usr/local
 
 CXXFLAGS ?= -g $(OPT) -Wall -Wextra -Woverloaded-virtual -pedantic -std=c++0x -fPIC
-CXXFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json
+CXXFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json -Ithird_party/rapidyaml/rapidyaml/src/ -Ithird_party/rapidyaml/rapidyaml/ext/c4core/src/
 CFLAGS ?= -g $(OPT) -Wall -Wextra -pedantic -std=c99 -fPIC
 CFLAGS += -Iinclude
-MAKEDEPENDFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json
+MAKEDEPENDFLAGS += -Iinclude -Ithird_party/md5 -Ithird_party/json -Ithird_party/rapidyaml/rapidyaml/src/ -Ithird_party/rapidyaml/rapidyaml/ext/c4core/src/
 EMCXXFLAGS = $(CXXFLAGS) --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s INLINING_LIMIT=50 -s RESERVED_FUNCTION_POINTERS=20 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
 EMCFLAGS = $(CFLAGS) --memory-init-file 0 -s DISABLE_EXCEPTION_CATCHING=0 -s ASSERTIONS=1 -s ALLOW_MEMORY_GROWTH=1
 LDFLAGS ?=
@@ -49,6 +49,10 @@
 ################################################################################
 # End of user-servicable parts
 ################################################################################
+
+RAPIDYAML_SRC = \
+	$(wildcard third_party/rapidyaml/rapidyaml/src/c4/yml/*.cpp) \
+	$(wildcard third_party/rapidyaml/rapidyaml/ext/c4core/src/c4/*.cpp)
 
 LIB_SRC = \
 	core/desugarer.cpp \
@@ -60,7 +64,8 @@
 	core/static_analysis.cpp \
 	core/string_utils.cpp \
 	core/vm.cpp \
-	third_party/md5/md5.cpp
+	third_party/md5/md5.cpp \
+	$(RAPIDYAML_SRC)
 
 LIB_OBJ = $(LIB_SRC:.cpp=.o)
 
@@ -110,6 +115,7 @@
 	core/std.jsonnet.h \
 	third_party/md5/md5.h \
 	third_party/json/json.hpp \
+	third_party/rapidyaml/rapidyaml/src/ryml_std.hpp \
 	$(INCS)

## jsonnet 0.18.0+ds

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 # CMake prepends CMAKE_SHARED_LIBRARY_PREFIX to shared libraries, so without
 # this step the output would be |liblibjsonnet|.
 set_target_properties(libjsonnet++ PROPERTIES OUTPUT_NAME jsonnet++
-	VERSION     "0.17.0"
+	VERSION     "0.18.0"
 	SOVERSION   "0"
 	PUBLIC_HEADER "${LIB_HEADER}")
 install(TARGETS libjsonnet++

=== stdlib/CMakeLists.txt ===
# Utility to convert file to a list of integeters.

add_executable(to_c_array to_c_array.cpp)

# Custom command that will only build stdlib when it changes.
add_custom_command(
	OUTPUT ${PROJECT_SOURCE_DIR}/core/std.jsonnet.h
	COMMAND ${GLOBAL_OUTPUT_PATH}/to_c_array
			    ${PROJECT_SOURCE_DIR}/stdlib/std.jsonnet
					${PROJECT_SOURCE_DIR}/core/std.jsonnet.h
	DEPENDS to_c_array std.jsonnet)

# Standard library build target that libjsonnet can depend on.
add_custom_target(stdlib ALL
	DEPENDS ${PROJECT_SOURCE_DIR}/core/std.jsonnet.h)

=== third_party/rapidyaml/rapidyaml/test/CMakeLists.txt ===
c4_setup_testing(GTEST)

c4_add_executable(ryml-parse-emit
    SOURCES parse_emit.cpp
    LIBS ryml c4fs
    FOLDER test)

c4_add_library(ryml-_testlib LIBRARY_TYPE STATIC
    SOURCES test_case.hpp test_case.cpp libyaml.hpp
    INC_DIRS ${CMAKE_CURRENT_LIST_DIR} ${ryml_yaml_cpp_inc}
    LIBS ryml c4fs yaml yaml-cpp gtest
    FOLDER test)
if(RYML_DBG)
    target_compile_definitions(ryml-_testlib PUBLIC RYML_DBG)
endif()

function(ryml_add_test test_name)
    set(t ryml-test-${test_name})
    c4_add_executable(${t}
        SOURCES test_${test_name}.cpp
        LIBS ${ARGN} ryml-_testlib gtest_main
        FOLDER test)
    if(RYML_DBG)
        target_compile_definitions(${t} PRIVATE RYML_DBG)
    endif()
    c4_add_test(${t})
endfunction()

c4_add_library(ryml-_testgroup LIBRARY_TYPE OBJECT
    SOURCES test_group.cpp test_group.hpp
    LIBS ryml ryml-_testlib c4fs
    FOLDER test)

function(ryml_add_test_case_group name)
    ryml_add_test(${name} ryml-_testgroup)
endfunction()

ryml_add_test(basic)
ryml_add_test(stack)
ryml_add_test(basic_json)
ryml_add_test(preprocess)
ryml_add_test(merge)
ryml_add_test_case_group(empty_file)
ryml_add_test_case_group(empty_doc)
ryml_add_test_case_group(simple_doc)
ryml_add_test_case_group(empty_map)
ryml_add_test_case_group(empty_seq)
ryml_add_test_case_group(simple_map)
ryml_add_test_case_group(simple_seq)
ryml_add_test_case_group(simple_set)
ryml_add_test_case_group(single_quoted)
ryml_add_test_case_group(double_quoted)
ryml_add_test_case_group(plain_scalar)
ryml_add_test_case_group(block_literal)
ryml_add_test_case_group(block_folded)
ryml_add_test_case_group(tag_property)
ryml_add_test_case_group(complex_key)
ryml_add_test_case_group(nested_mapx2)
ryml_add_test_case_group(nested_seqx2)
ryml_add_test_case_group(nested_mapx3)
ryml_add_test_case_group(nested_seqx3)
ryml_add_test_case_group(nested_mapx4)
ryml_add_test_case_group(nested_seqx4)
ryml_add_test_case_group(map_of_seq)
ryml_add_test_case_group(seq_of_map)
ryml_add_test_case_group(generic_map)
ryml_add_test_case_group(generic_seq)
ryml_add_test_case_group(scalar_names)
ryml_add_test_case_group(simple_anchor)
ryml_add_test_case_group(indentation)
ryml_add_test_case_group(number)
ryml_add_test_case_group(null_val)
ryml_add_test_case_group(github_issues)

c4_add_install_include_test(ryml "ryml::")
c4_add_install_link_test(ryml "ryml::" "
#include <c4/yml/yml.hpp>

int main()
{
    auto tree = c4::yml::parse(R\"(
a: 1
b: {b0: 2, b1: 3}
c: [4, 5, 6]
)\");
    #define check(cond) if(!(cond)) { return __LINE__; }
    check(!tree.empty())
    check(tree.rootref().is_map())
    check(tree.rootref().num_children() == 3)
    check(tree[\"a\"].is_keyval())
    check(tree[\"a\"].num_children() == 0)
    check(tree[\"a\"].val() == \"1\")
    check(tree[\"b\"].is_map())
    check(tree[\"b\"].num_children() == 2)
    check(tree[\"b\"][\"b0\"].val() == \"2\")
    check(tree[\"b\"][\"b1\"].val() == \"3\")
    check(tree[\"c\"].is_seq())
    check(tree[\"c\"].num_children() == 3)
    check(tree[\"c\"][0].val() == \"4\")
    check(tree[\"c\"][1].val() == \"5\")
    check(tree[\"c\"][2].val() == \"6\")
    return 0;
}
")


#-------------------------------------------------------------------------

# run every case in the yaml-test-suite
option(RYML_TEST_SUITE "Enable ~300 extensive test cases from yaml-test-suite, https://github.com/yaml/yaml-test-suite." OFF)

if(RYML_TEST_SUITE)
    set(ed ${CMAKE_CURRENT_BINARY_DIR}/ext) # casual ryml extern dir (these projects are not part of ryml and are downloaded and compiled on the fly)

    c4_require_subproject(c4log REMOTE
        GIT_REPOSITORY https://github.com/biojppm/c4log
        GIT_TAG master)

    set(tsdir ${ed}/yaml-test-suite)
    c4_download_remote_proj(yaml-test-suite tsdir
        GIT_REPOSITORY https://github.com/yaml/yaml-test-suite
        GIT_TAG ed99dd31187f00d729fe160a7658f6f29c08f80b) #master)
    set(suite_dir ${tsdir}/test)
    if(NOT EXISTS ${suite_dir})
        c4_err("cannot find yaml-test-suite at ${suite_dir} -- was there an error downloading the project?")
    endif()

    c4_add_executable(ryml-test-suite
        SOURCES test_suite.cpp
        LIBS ryml-_testlib c4log
        FOLDER test)
    add_dependencies(ryml-test-build ryml-test-suite)

    set(tgt $<TARGET_FILE:ryml-test-suite>)
    function(ryml_add_test_from_suite tml_file)
        get_filename_component(name ${tml_file} NAME_WE)
        add_test(NAME ryml-test-suite-${name}-in_yaml   COMMAND ${tgt} --gtest_filter=*/in_yaml*   ${suite_dir}/${tml_file})
        add_test(NAME ryml-test-suite-${name}-out_yaml  COMMAND ${tgt} --gtest_filter=*/out_yaml*  ${suite_dir}/${tml_file})
        add_test(NAME ryml-test-suite-${name}-emit_yaml COMMAND ${tgt} --gtest_filter=*/emit_yaml* ${suite_dir}/${tml_file})
        add_test(NAME ryml-test-suite-${name}-in_json   COMMAND ${tgt} --gtest_filter=*/in_json*   ${suite_dir}/${tml_file})
    endfunction()

    file(GLOB suite_cases RELATIVE "${suite_dir}" "${suite_dir}/*.tml")
    foreach(case ${suite_cases})
        ryml_add_test_from_suite(${case})
    endforeach()

endif(RYML_TEST_SUITE)

=== third_party/rapidyaml/rapidyaml/ext/c4core/bm/CMakeLists.txt ===
c4_setup_benchmarking()

#----------------------------------------------

# libraries to compare

c4_require_subproject(fp
  REMOTE
    GIT_REPOSITORY https://github.com/jk-jeon/fp
    GIT_TAG master)

# ryu requires too much code; use an include for clarity
include(./ryu.cmake)


#----------------------------------------------

c4_add_executable(c4core-bm-format
    SOURCES bm_format.cpp
    LIBS c4core benchmark
    FOLDER bm)

c4_add_target_benchmark(c4core-bm-format cat FILTER "^cat_.*")
c4_add_target_benchmark(c4core-bm-format catsep FILTER "^catsep_.*")
c4_add_target_benchmark(c4core-bm-format format FILTER "^format_.*")


#----------------------------------------------

c4_add_executable(c4core-bm-charconv
    SOURCES bm_charconv.cpp
    LIBS c4core benchmark ryu_c4
    INC_DIRS ${C4CORE_SRC_DIR}/c4/ext/fast_float/include
    FOLDER bm)

get_property(known_features GLOBAL PROPERTY CMAKE_CXX_KNOWN_FEATURES)
if(cxx_std_17 IN_LIST known_features)
    target_link_libraries(c4core-bm-charconv PRIVATE jkj_fp)
endif()


function(c4core_charconv_benchmark pfx)
    foreach(case ${ARGN})
        c4_add_target_benchmark(c4core-bm-charconv ${pfx}-${case} FILTER "^${pfx}.*<${case}.*")
    endforeach()
endfunction()

c4core_charconv_benchmark(xtoa uint8 int8 uint16 int16 uint32 int32 uint64 int64 float double)
c4core_charconv_benchmark(atox uint8 int8 uint16 int16 uint32 int32 uint64 int64 float double)


#----------------------------------------------

option(C4CORE_BM_FLOAT_CMP "compare between alternative implementations for reading/writing floats" ON)
if(C4CORE_BM_FLOAT_CMP)
    add_subdirectory(float)
endif()

=== debian/changelog ===
jsonnet (0.18.0+ds-3build2) lunar; urgency=medium

  * Rebuild to drop Python 3.10 extension

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 28 Feb 2023 17:21:57 -0500

jsonnet (0.18.0+ds-3build1) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as supported

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 02 Nov 2022 10:20:41 +0000

jsonnet (0.18.0+ds-3) unstable; urgency=medium

  * Add riscv64 architecture (Closes: #1014598)

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sun, 31 Jul 2022 13:57:45 +0000

jsonnet (0.18.0+ds-2) unstable; urgency=medium

  * fix FTBFS on several release architectures (Closes: #1013310)
  * fix FTBFS error on armel
  * Allow only specific architectures as build targets

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Sat, 02 Jul 2022 13:23:19 +0000

jsonnet (0.18.0+ds-1) unstable; urgency=medium

  * Adopt package (Closes: #1012294)
  * New upstream version 0.18.0+ds
  * Update d/copyright to adapt to upstream
  * Remove tests-dont-use-python2.patch.
    This is because tests in upstream have moved to Python 3 only.

 -- Fukui Daichi <a.dog.will.talk@akane.waseda.jp>  Mon, 20 Jun 2022 13:00:37 +0000
